//+------------------------------------------------------------------+
//|                                                    MA_Shadow.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                  https://www.mql5.com/ru/users/nikolay7ko/seller |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com/ru/users/nikolay7ko/seller"
#property version   "1.00"
#property indicator_chart_window
#include <Canvas\iCanvas.mqh> //https://www.mql5.com/ru/code/22164
int per =100;
int handle;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit() {
   handle = iMA(_Symbol,PERIOD_CURRENT,per,0,MODE_SMA,PRICE_CLOSE);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[]) {
   Draw();
   return(rates_total);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam) {
   if (id == CHARTEVENT_MOUSE_MOVE) {
      per =  int(3+(W.Width - lparam)/3);
      if (per<1) per = 1;
      handle = iMA(_Symbol,PERIOD_CURRENT,per,0,MODE_SMA,PRICE_CLOSE);
      Draw();
   }


}
//+------------------------------------------------------------------+
void Draw() {
   //ulong t = GetMicrosecondCount();
   double a[];
   int lb =Floor(W.Right_bar);
   CopyBuffer(handle,0,lb,W.BarsInWind,a);
   Canvas.Erase(0x00FFFFFF);
   for (int i = lb+1, j = W.BarsInWind-2; i<W.Left_bar; i++, j--) {
      Canvas.iLine(_X(double(i-1))+2, _Y(a[j+1])+2, _X(double(i))+2, _Y(a[j])+2,0xA0808080,1,2,false);
      Canvas.iLine(_X(double(i-1)), _Y(a[j+1]), _X(double(i)), _Y(a[j]),0xFFCC00FF,1.414,0.707,false);
   }
   Canvas.Update();
   //t = GetMicrosecondCount() - t;
   //Print(t);
}
//+------------------------------------------------------------------+
